diff -uNrw asterisk-1.8.19.0/.cleancount asterisk-1.8.20.0-rc1/.cleancount
--- asterisk-1.8.19.0/.cleancount	2011-01-31 07:41:36.000000000 +0100
+++ asterisk-1.8.20.0-rc1/.cleancount	2012-11-06 19:18:32.000000000 +0100
@@ -1,3 +1 @@
-39
-
-
+40
diff -uNrw asterisk-1.8.19.0/include/asterisk/astmm.h asterisk-1.8.20.0-rc1/include/asterisk/astmm.h
--- asterisk-1.8.19.0/include/asterisk/astmm.h	2010-06-08 16:38:18.000000000 +0200
+++ asterisk-1.8.20.0-rc1/include/asterisk/astmm.h	2012-11-08 17:58:52.000000000 +0100
@@ -65,7 +65,8 @@
 	__attribute__((format(printf, 5, 6)));
 int __ast_vasprintf(char **strp, const char *format, va_list ap, const char *file, int lineno, const char *func)
 	__attribute__((format(printf, 2, 0)));
-void __ast_mm_init(void);
+void __ast_mm_init_phase_1(void);
+void __ast_mm_init_phase_2(void);
 
 
 /* Provide our own definitions */
diff -uNrw asterisk-1.8.19.0/include/asterisk/channel.h asterisk-1.8.20.0-rc1/include/asterisk/channel.h
--- asterisk-1.8.19.0/include/asterisk/channel.h	2012-09-13 20:39:40.000000000 +0200
+++ asterisk-1.8.20.0-rc1/include/asterisk/channel.h	2012-11-07 18:01:13.000000000 +0100
@@ -870,6 +870,8 @@
 	char macrocontext[AST_MAX_CONTEXT];		/*!< Macro: Current non-macro context. See app_macro.c */
 	char macroexten[AST_MAX_EXTENSION];		/*!< Macro: Current non-macro extension. See app_macro.c */
 	char emulate_dtmf_digit;			/*!< Digit being emulated */
+	char sending_dtmf_digit;			/*!< Digit this channel is currently sending out. (zero if not sending) */
+	struct timeval sending_dtmf_tv;		/*!< The time this channel started sending the current digit. (Invalid if sending_dtmf_digit is zero.) */
 };
 
 /*! \brief ast_channel_tech Properties */
@@ -1686,7 +1688,7 @@
 /*!
  * \brief Wait for a specified amount of time, looking for hangups
  * \param chan channel to wait for
- * \param ms length of time in milliseconds to sleep
+ * \param ms length of time in milliseconds to sleep. This should never be less than zero.
  * \details
  * Waits for a specified amount of time, servicing the channel as required.
  * \return returns -1 on hangup, otherwise 0.
@@ -1696,7 +1698,7 @@
 /*!
  * \brief Wait for a specified amount of time, looking for hangups and a condition argument
  * \param chan channel to wait for
- * \param ms length of time in milliseconds to sleep
+ * \param ms length of time in milliseconds to sleep.
  * \param cond a function pointer for testing continue condition
  * \param data argument to be passed to the condition test function
  * \return returns -1 on hangup, otherwise 0.
diff -uNrw asterisk-1.8.19.0/include/asterisk/features.h asterisk-1.8.20.0-rc1/include/asterisk/features.h
--- asterisk-1.8.19.0/include/asterisk/features.h	2011-10-20 23:54:11.000000000 +0200
+++ asterisk-1.8.20.0-rc1/include/asterisk/features.h	2012-11-06 19:18:32.000000000 +0100
@@ -169,6 +169,18 @@
 /*! \brief Determine system call pickup extension */
 const char *ast_pickup_ext(void);
 
+/*!
+ * \brief Simulate a DTMF end on a broken bridge channel.
+ *
+ * \param chan Channel sending DTMF that has not ended.
+ * \param digit DTMF digit to stop.
+ * \param start DTMF digit start time.
+ * \param why Reason bridge broken.
+ *
+ * \return Nothing
+ */
+void ast_bridge_end_dtmf(struct ast_channel *chan, char digit, struct timeval start, const char *why);
+
 /*! \brief Bridge a call, optionally allowing redirection */
 int ast_bridge_call(struct ast_channel *chan, struct ast_channel *peer,struct ast_bridge_config *config);
 
diff -uNrw asterisk-1.8.19.0/include/asterisk/hashtab.h asterisk-1.8.20.0-rc1/include/asterisk/hashtab.h
--- asterisk-1.8.19.0/include/asterisk/hashtab.h	2009-03-11 01:29:59.000000000 +0100
+++ asterisk-1.8.20.0-rc1/include/asterisk/hashtab.h	2012-11-15 23:27:37.000000000 +0100
@@ -23,6 +23,9 @@
  * \brief Generic (perhaps overly so) hashtable implementation
  * \ref AstHash
  */
+
+#include "asterisk/lock.h"
+
 /*! \page AstHash Hash Table support in Asterisk
 
 A hash table is a structure that allows for an exact-match search
diff -uNrw asterisk-1.8.19.0/include/asterisk/linkedlists.h asterisk-1.8.20.0-rc1/include/asterisk/linkedlists.h
--- asterisk-1.8.19.0/include/asterisk/linkedlists.h	2011-10-29 06:19:42.000000000 +0200
+++ asterisk-1.8.20.0-rc1/include/asterisk/linkedlists.h	2012-11-27 18:28:43.000000000 +0100
@@ -834,33 +834,37 @@
  * \param elm This is a pointer to the entry to be removed.
  * \param field This is the name of the field (declared using AST_LIST_ENTRY())
  * used to link entries of this list together.
- * \warning The removed entry is \b not freed nor modified in any way.
+ * \retval elm if elm was in the list.
+ * \retval NULL if elm was not in the list or elm was NULL.
+ * \warning The removed entry is \b not freed.
  */
-#define AST_LIST_REMOVE(head, elm, field) ({			        \
-	__typeof(elm) __res = NULL; \
-	__typeof(elm) __tmp = elm; \
-	if (!__tmp) { \
-		__res = NULL; \
-	} else if ((head)->first == (elm)) {					\
-		__res = (head)->first;                      \
-		(head)->first = (elm)->field.next;			\
-		if ((head)->last == (elm))			\
+#define AST_LIST_REMOVE(head, elm, field)						\
+	({															\
+		__typeof(elm) __elm = (elm);							\
+		if (__elm) {											\
+			if ((head)->first == __elm) {						\
+				(head)->first = __elm->field.next;				\
+				__elm->field.next = NULL;						\
+				if ((head)->last == __elm) {					\
 			(head)->last = NULL;			\
+				}												\
+			} else {											\
+				typeof(elm) __prev = (head)->first;				\
+				while (__prev && __prev->field.next != __elm) {	\
+					__prev = __prev->field.next;				\
+				}												\
+				if (__prev) {									\
+					__prev->field.next = __elm->field.next;		\
+					__elm->field.next = NULL;					\
+					if ((head)->last == __elm) {				\
+						(head)->last = __prev;					\
+					}											\
 	} else {								\
-		typeof(elm) curelm = (head)->first;			\
-		while (curelm && (curelm->field.next != (elm)))			\
-			curelm = curelm->field.next;			\
-		if (curelm) { \
-			__res = (elm); \
-			curelm->field.next = (elm)->field.next;			\
-			if ((head)->last == (elm))				\
-				(head)->last = curelm;				\
+					__elm = NULL;								\
 		} \
 	}								\
-	if (__res) { \
-		(__res)->field.next = NULL; \
 	} \
-	(__res); \
+		__elm;													\
 })
 
 #define AST_RWLIST_REMOVE AST_LIST_REMOVE
diff -uNrw asterisk-1.8.19.0/include/asterisk/lock.h asterisk-1.8.20.0-rc1/include/asterisk/lock.h
--- asterisk-1.8.19.0/include/asterisk/lock.h	2011-01-31 08:51:40.000000000 +0100
+++ asterisk-1.8.20.0-rc1/include/asterisk/lock.h	2012-11-23 00:51:02.000000000 +0100
@@ -428,12 +428,24 @@
 
 static inline void ast_reentrancy_lock(struct ast_lock_track *lt)
 {
-	pthread_mutex_lock(&lt->reentr_mutex);
+	int res;
+	if ((res = pthread_mutex_lock(&lt->reentr_mutex))) {
+		fprintf(stderr, "ast_reentrancy_lock failed: '%s' (%d)\n", strerror(res), res);
+#if defined(DO_CRASH) || defined(THREAD_CRASH)
+		abort();
+#endif
+	}
 }
 
 static inline void ast_reentrancy_unlock(struct ast_lock_track *lt)
 {
-	pthread_mutex_unlock(&lt->reentr_mutex);
+	int res;
+	if ((res = pthread_mutex_unlock(&lt->reentr_mutex))) {
+		fprintf(stderr, "ast_reentrancy_unlock failed: '%s' (%d)\n", strerror(res), res);
+#if defined(DO_CRASH) || defined(THREAD_CRASH)
+		abort();
+#endif
+	}
 }
 
 static inline void ast_reentrancy_init(struct ast_lock_track **plt)
diff -uNrw asterisk-1.8.19.0/include/asterisk/_private.h asterisk-1.8.20.0-rc1/include/asterisk/_private.h
--- asterisk-1.8.19.0/include/asterisk/_private.h	2010-05-19 23:29:08.000000000 +0200
+++ asterisk-1.8.20.0-rc1/include/asterisk/_private.h	2012-12-03 21:26:37.000000000 +0100
@@ -19,6 +19,7 @@
 int load_pbx(void);			/*!< Provided by pbx.c */
 int init_logger(void);			/*!< Provided by logger.c */
 void close_logger(void);		/*!< Provided by logger.c */
+void clean_time_zones(void);			/*!< Provided by localtime.c */
 int init_framer(void);			/*!< Provided by frame.c */
 int ast_term_init(void);		/*!< Provided by term.c */
 int astdb_init(void);			/*!< Provided by db.c */
diff -uNrw asterisk-1.8.19.0/include/asterisk/time.h asterisk-1.8.20.0-rc1/include/asterisk/time.h
--- asterisk-1.8.19.0/include/asterisk/time.h	2012-04-27 21:26:37.000000000 +0200
+++ asterisk-1.8.20.0-rc1/include/asterisk/time.h	2012-11-07 18:01:13.000000000 +0100
@@ -152,6 +152,20 @@
 struct timeval ast_tvsub(struct timeval a, struct timeval b);
 
 /*!
+ * \brief Calculate remaining milliseconds given a starting timestamp
+ * and upper bound
+ *
+ * If the upper bound is negative, then this indicates that there is no
+ * upper bound on the amount of time to wait. This will result in a
+ * negative return.
+ *
+ * \param start When timing started being calculated
+ * \param max_ms The maximum number of milliseconds to wait from start. May be negative.
+ * \return The number of milliseconds left to wait for. May be negative.
+ */
+int ast_remaining_ms(struct timeval start, int max_ms);
+
+/*!
  * \brief Returns a timeval from sec, usec
  */
 AST_INLINE_API(
diff -uNrw asterisk-1.8.19.0/include/asterisk/utils.h asterisk-1.8.20.0-rc1/include/asterisk/utils.h
--- asterisk-1.8.19.0/include/asterisk/utils.h	2012-07-31 21:31:42.000000000 +0200
+++ asterisk-1.8.20.0-rc1/include/asterisk/utils.h	2012-11-08 17:58:52.000000000 +0100
@@ -706,32 +706,27 @@
 
 
 #ifdef AST_DEVMODE
+void __ast_assert_failed(int condition, const char *condition_str, const char *file, int line, const char *function);
 #define ast_assert(a) _ast_assert(a, # a, __FILE__, __LINE__, __PRETTY_FUNCTION__)
-static void force_inline _ast_assert(int condition, const char *condition_str, 
-	const char *file, int line, const char *function)
+static void force_inline _ast_assert(int condition, const char *condition_str, const char *file, int line, const char *function)
 {
 	if (__builtin_expect(!condition, 1)) {
-		/* Attempt to put it into the logger, but hope that at least someone saw the
-		 * message on stderr ... */
-		ast_log(__LOG_ERROR, file, line, function, "FRACK!, Failed assertion %s (%d)\n",
-			condition_str, condition);
-		fprintf(stderr, "FRACK!, Failed assertion %s (%d) at line %d in %s of %s\n",
-			condition_str, condition, line, function, file);
-		/* Give the logger a chance to get the message out, just in case we abort(), or
-		 * Asterisk crashes due to whatever problem just happened after we exit ast_assert(). */
-		usleep(1);
-#ifdef DO_CRASH
-		abort();
-		/* Just in case abort() doesn't work or something else super silly,
-		 * and for Qwell's amusement. */
-		*((int*)0)=0;
-#endif
+		__ast_assert_failed(condition, condition_str, file, line, function);
 	}
 }
 #else
 #define ast_assert(a)
 #endif
 
+/*!
+ * \brief Force a crash if DO_CRASH is defined.
+ *
+ * \note If DO_CRASH is not defined then the function returns.
+ *
+ * \return Nothing
+ */
+void ast_do_crash(void);
+
 #include "asterisk/strings.h"
 
 /*!
diff -uNrw asterisk-1.8.19.0/.lastclean asterisk-1.8.20.0-rc1/.lastclean
--- asterisk-1.8.19.0/.lastclean	2012-11-06 17:23:40.000000000 +0100
+++ asterisk-1.8.20.0-rc1/.lastclean	2012-12-10 02:48:00.000000000 +0100
@@ -1,3 +1 @@
-39
-
-
+40
